dnl
dnl This file is part of the Score-P software (http://www.score-p.org)
dnl
dnl Copyright (c) 2021,
dnl Forschungszentrum Juelich GmbH, Germany
dnl
dnl This software may be modified and distributed under the terms of
dnl a BSD-style license.  See the COPYING file in the package base
dnl directory for details.
dnl

AC_DEFUN_ONCE([AFS_OPENMP_CC], [
AC_REQUIRE([_AFS_OPENMP_CC_CHECK])
AC_LANG_PUSH([C])
_AFS_OPENMP_SUMMARY
AC_LANG_POP([C])
])

AC_DEFUN_ONCE([AFS_OPENMP_CXX], [
AC_REQUIRE([_AFS_OPENMP_CXX_CHECK])
AC_LANG_PUSH([C++])
_AFS_OPENMP_SUMMARY
AC_LANG_POP([C++])
])

AC_DEFUN_ONCE([AFS_OPENMP_F77], [
AC_REQUIRE([_AFS_OPENMP_F77_CHECK])
AC_LANG_PUSH([F77])
_AFS_OPENMP_SUMMARY
AC_LANG_POP([F77])
])

AC_DEFUN_ONCE([AFS_OPENMP_FC], [
AC_REQUIRE([_AFS_OPENMP_FC_CHECK])
AC_LANG_PUSH([Fortran])
_AFS_OPENMP_SUMMARY
AC_LANG_POP([Fortran])
])

AC_DEFUN([_AFS_OPENMP_CC_CHECK], [
AC_LANG_PUSH([C])
_AFS_OPENMP_CHECK
AC_LANG_POP([C])
])

AC_DEFUN([_AFS_OPENMP_CXX_CHECK], [
AC_LANG_PUSH([C++])
_AFS_OPENMP_CHECK
AC_LANG_POP([C++])
])

AC_DEFUN([_AFS_OPENMP_F77_CHECK], [
AC_LANG_PUSH([F77])
_AFS_OPENMP_CHECK
AC_LANG_POP([F77])
])

AC_DEFUN([_AFS_OPENMP_FC_CHECK], [
AC_LANG_PUSH([Fortran])
_AFS_OPENMP_CHECK
AC_LANG_POP([Fortran])
])

# _AFS_OPENMP_CHECK
# -----------------
#
AC_DEFUN([_AFS_OPENMP_CHECK], [dnl
dnl Unset FLAGS temporarily because Cray compilers ignore OpenMP
dnl flags if -g is (automagically) set.
omp_save_[]_AC_LANG_ABBREV[]flags=${_AC_LANG_PREFIX[]FLAGS}
_AC_LANG_PREFIX[]FLAGS=
_AFS_OPENMP
AFS_AM_CONDITIONAL([HAVE_OPENMP_]_AC_LANG_PREFIX[_SUPPORT],
    [test "x${ac_cv_prog_[]_AC_LANG_ABBREV[]_openmp}" != xunsupported],
    [FALSE])dnl
_AC_LANG_PREFIX[]FLAGS="${OPENMP_[]_AC_LANG_PREFIX[]FLAGS}"
AS_IF([test "x${ac_cv_prog_[]_AC_LANG_ABBREV[]_openmp}" != xunsupported],
    [m4_case(_AC_CC,
         [F77], [],
         [FC],  [],
	 [AC_COMPUTE_INT([afs_openmp_[]_AC_LANG_ABBREV[]_version], [_OPENMP])])])
_AC_LANG_PREFIX[]FLAGS=${omp_save_[]_AC_LANG_ABBREV[]flags}
]) #AFS_OPENMP_CHECK


# _AFS_OPENMP_SUMMARY
# -------------------
#
AC_DEFUN([_AFS_OPENMP_SUMMARY], [
AS_IF([test "x${ac_cv_prog_[]_AC_LANG_ABBREV[]_openmp}" != xunsupported],
    [m4_case(_AC_LANG_PREFIX,
         [F77], [AFS_SUMMARY([OpenMP _AC_LANG support], [yes, using ${OPENMP_[]_AC_LANG_PREFIX[]FLAGS}])],
         [FC],  [AFS_SUMMARY([OpenMP _AC_LANG support], [yes, using ${OPENMP_[]_AC_LANG_PREFIX[]FLAGS}])],
	 [AFS_SUMMARY([OpenMP _AC_LANG support], [yes, using ${OPENMP_[]_AC_LANG_PREFIX[]FLAGS}, version ${afs_openmp_[]_AC_LANG_ABBREV[]_version}])])],
    [AFS_SUMMARY([OpenMP _AC_LANG support], [no, no suitable compiler options found])])
]) # _AFS_OPENMP_SUMMARY
